﻿@model StarterProjectV2.ViewModels.OwnerRoomBookingManagementView
@{
    ViewData["Title"] = "All Owner Reservations";
}
<meta name="viewport" content="width=device-width, initial-scale=1.0">
@section PAGETITLE{
    Owner Room Booking Management
}
<!DOCTYPE html>
<script>
    $(function () {

        if ('@TempData["Message"]') {

            showToastr('error', '@TempData["Message"]')
        }
    });
</script>

<body style="background-color: oldlace">
    <div class="card" style="margin-bottom: 0">
        <h2 class="text-center mt-3" style="color:indianred">@ViewData["Title"]</h2>

        <div class="card-body">
            <form class="form-inline mb-3 ml-3 d-flex justify-content-center">
                <div class="form-group row mb-3">
                    Approval :
                    @Html.DropDownList("complete", new SelectList(CommonHelper.dictBookingStatus, "Value", "Key", Model.BookingComplete), new { @class = "form-control", style = "margin-left:1rem; margin-right:1rem;" })

                    Token Assigned :
                    @Html.DropDownList("tokenassigned", new SelectList(CommonHelper.dictYesNo, "Value", "Key", Model.TokenAssigned), new { @class = "form-control", style = "margin-left:1rem; margin-right:1rem;" })

                    Checked In :
                    @Html.DropDownList("checkedin", new SelectList(CommonHelper.dictYesNo, "Value", "Key", Model.CheckedIn), new { @class = "form-control", style = "margin-left:1rem; margin-right:1rem;" })

                    Checked Out :
                    @Html.DropDownList("checkedout", new SelectList(CommonHelper.dictYesNo, "Value", "Key", Model.CheckedOut), new { @class = "form-control", style = "margin-left:1rem; margin-right:1rem;" })
                </div>

                <div class="form-group row mb-3">
                    From Date :
                    @Html.TextBox("FromDate", "", new { @class = "form-control", type = "date", style = "margin-left:1rem; margin-right:1rem;" })
                    To Date :
                    @Html.TextBox("ToDate", "", new { @class = "form-control", type = "date", style = "margin-left:1rem; margin-right:1rem;" })

                    @Html.TextBoxFor(m => m.SearchField, new {@Id= "searchfield", @class = "form-control", placeholder = "SlotId / Booking No / Guest Name" })

                    <button class="btn btn-primary" type="button" onclick="search()">Search</button>
                </div>

            </form>

            <div class="table-responsive-lg" id="table">
                @{
                    int noOfbooking = Model.OwnerRoomBookingListCurrent.Count();
                }
                @if (noOfbooking != 0)
                {
                    <table id="mainTable1" data-pagination="true" class="table  table-light  table-hover" style="margin-bottom: 0">
                        <thead style="color: white; background-color:#315152">
                            <tr>
                                <th scope="col">Slot Id</th>
                                <th scope="col">Main Guest Name</th>
                                <th scope="col">Booking Application Date</th>
                                <th scope="col">Booking No.</th>


                                <th scope="col">No of Room</th>
                                <th scope="col">Arrival Date</th>
                                <th scope="col">Departure Date</th>
                                <th scope="col">Booking Status</th>
                                <th scope="col">Checked In</th>
                                <th scope="col">Insert\Edit Booking No.</th>
                                <th scope="col">Confirm Check In</th>
                                <th scope="col">Confirm Check Out</th>
                                <th scope="col">Folio Detail</th>

                                @*<th scope="col">View</th>*@
                                <th scope="col">Edit</th>
                                <th scope="col">
                                    Cancel
                                </th>

                            </tr>
                        </thead>
                        <tbody>
                            @foreach (var ownerRoomBooking in Model.OwnerRoomBookingListCurrent)
                            {
                                <tr>
                                    <td>@ownerRoomBooking.SlotId</td>
                                    <td>@ownerRoomBooking.GuestNameMain</td>

                                    <td>@ownerRoomBooking.ApplicationDate.ToString("dd-MM-yyyy")</td>
                                    @if (string.IsNullOrWhiteSpace(ownerRoomBooking.BookingToken))
                                    {
                                        <td>Not Assigned</td>
                                    }
                                    else
                                    {
                                        <td>@ownerRoomBooking.BookingToken</td>
                                    }


                                    <td>@ownerRoomBooking.NoOfRoomRequested </td>
                                    @{
                                        var Startdate = (ownerRoomBooking.CheckInDate);
                                        var val1 = Startdate.ToString("dd-MM-yyyy");
                                        <td>@val1</td>
                                    }
                                    @{
                                        var Enddate = Convert.ToDateTime(ownerRoomBooking.CheckOutDate);
                                        var val2 = Enddate.ToString("dd-MM-yyyy");
                                        <td>@val2</td>
                                    }

                                    @if (ownerRoomBooking.IsBookingCompleted == "No")
                                    {
                                        <td>Pending</td>
                                    }
                                    else if (ownerRoomBooking.IsBookingCompleted == "Yes")
                                    {
                                        if (!string.IsNullOrWhiteSpace(ownerRoomBooking.BookingToken))
                                        {
                                            <td>Approved<i class="fa fa-check" aria-hidden="true"></i></td>
                                        }
                                        else
                                        {
                                            <td>Requested<i class="fa fa-check fa-2x" aria-hidden="true"></i></td>
                                        }
                                    }
                                    else if (ownerRoomBooking.IsBookingCompleted == "Cancelled")
                                    {
                                        <td>Cancelled<i class="fa fa-close" aria-hidden="true"></i></td>
                                    }
                                    else
                                    {
                                        <td>@ownerRoomBooking.IsBookingCompleted</td>
                                    }
                                    <td>@ownerRoomBooking.HasStayedOrNot</td>
                                    <td>
                                        @if (ownerRoomBooking.IsBookingCompleted == "Yes")
                                        {
                                            <button type="button"
                                                    class="btn btn-light"
                                                    data-toggle="tooltip"
                                                    data-placement="bottom"
                                                    title="Insert Token"
                                                    onclick="location.href = '@Url.Action("TokenForm", "Booking", new { bookingid = ownerRoomBooking.OwnerRoomBookngId })'">
                                                <i class="icon-notebook">
                                                </i>
                                            </button>
                                        }
                                    </td>
                                    <td>
                                        @if (ownerRoomBooking.IsBookingCompleted == "Yes" && ownerRoomBooking.BookingToken != ""
                                            && (String.IsNullOrEmpty(ownerRoomBooking.HasStayedOrNot) || ownerRoomBooking.HasStayedOrNot == "No")
                                            && ownerRoomBooking.CheckInDate <= DateTime.Today)
                                        {
                                            <button type="button"
                                                    class="btn btn-light"
                                                    data-toggle="tooltip"
                                                    data-placement="bottom"
                                                    title="Confirm Check In"
                                                    onclick="location.href = '@Url.Action("CheckInForm", "Booking", new { bookingid = ownerRoomBooking.OwnerRoomBookngId })'">
                                                <i class="fa fa-calendar-check-o">
                                                </i>
                                            </button>
                                        }
                                    </td>
                                    <td>
                                        @if (ownerRoomBooking.HasStayedOrNot == "Yes" && String.IsNullOrEmpty(ownerRoomBooking.HasCheckedOutOrNot))
                                        {
                                            <button type="button"
                                                    class="btn btn-light"
                                                    data-toggle="tooltip"
                                                    data-placement="bottom"
                                                    title="Confirm Check Out"
                                                    onclick="location.href = '@Url.Action("CheckOutForm", "Booking", new { bookingid = ownerRoomBooking.OwnerRoomBookngId })'">
                                                Booking
                                                <i class="fa fa-calendar-times-o">
                                                </i>
                                            </button>
                                        }
                                    </td>
                                    <td>
                                        <button type="button"
                                                class="btn btn-light"
                                                data-toggle="tooltip"
                                                data-placement="bottom"
                                                title="View Folio"
                                                onclick="location.href = '@Url.Action("FolioDetail", "Booking", new {OwnerRoomBookngId = ownerRoomBooking.OwnerRoomBookngId})'">
                                            <i class="icon-eye">
                                            </i>
                                        </button>
                                    </td>
                                    <td>
                                        <button type="button"
                                                class="btn btn-light"
                                                data-toggle="tooltip"
                                                data-placement="bottom"
                                                title="Edit"
                                                onclick="location.href = '@Url.Action("OwnerRoomBookingEdit", "Booking", new {ownerRoomBookngId = ownerRoomBooking.OwnerRoomBookngId})'">
                                            <i class="icon-notebook">
                                            </i>
                                        </button>
                                    </td>
                                    <td>
                                        @if (ownerRoomBooking.IsBookingCompleted != "Cancelled")
                                        {
                                            using (Html.BeginForm("OwnerRoomBookingDelete", "Booking", new { ownerRoomBookingId = ownerRoomBooking.OwnerRoomBookngId }, FormMethod.Post))
                                            {
                                                <button type="submit"
                                                        class="btn btn-light"
                                                        data-toggle="tooltip"
                                                        data-placement="bottom"
                                                        title="Cancel"
                                                        onclick="functionforSMS()">
                                                    <i class="icon-trash">
                                                    </i>
                                                </button>
                                            }
                                        }
                                    </td>

                                </tr>
                            }

                        </tbody>
                    </table>
                }
                else
                {
                    <h3 align="center">No Bookings Found</h3>

                }
            </div>
            <div class="table-responsive-lg" id="js-table">
                <table id="dtBasicExample" data-pagination="true" class="table table-hover table-light" style="margin-bottom: 0"></table>
            </div>
            <div class="text-center" id="message">

            </div>
            @{
                int NoOfBooking = Model.NoOfBooking;
            }
            @if (NoOfBooking != 0)
            {
                <div class="pager" style="padding-top: 20px; direction: ltr; display: block;" align="center" id="pagination">

                    <nav aria-label="Page navigation example">
                        <ul class="pagination justify-content-center flex-wrap">
                            @{
                                int prev_idx = Model.index - 1;
                            }
                            <li class="page-item previous"><a class="page-link" href="#" onclick="paginationPureJS(1)">« First</a></li>
                            <li class="page-item previous"><a class="page-link" href="#" onclick="previous(@prev_idx, @Model.NoOfBooking)">« Previous</a></li>
                            @{
                                int idx = Model.index;
                                int next_idx = Model.index + 1;
                                int noOfPost = Model.NoOfBooking;
                                if (NoOfBooking < 10)
                                {
                                    for (int i = 1; i <= NoOfBooking; i++)
                                    {
                                        <li class="page-item" id="@i"><a class="page-link" href="#" onclick="paginationPureJS(@i)">@i</a></li>
                                    }
                                }
                                else
                                {
                                    if (idx <= 5)
                                    {
                                        if (NoOfBooking < 10)
                                        {
                                            for (int i = 1; i <= NoOfBooking; i++)
                                            {
                                                <li class="page-item" id="@i"><a class="page-link" href="#" onclick="paginationPureJS(@i)">@i</a></li>
                                            }
                                        }
                                        else
                                        {
                                            for (int i = 1; i <= 10; i++)
                                            {
                                                <li class="page-item" id="@i"><a class="page-link" href="#" onclick="paginationPureJS(@i)">@i</a></li>
                                            }
                                        }
                                    }
                                    else if (idx > 5 && idx <= (noOfPost - 5))
                                    {
                                        for (int i = idx - 4; i <= idx + 5; i++)
                                        {
                                            <li class="page-item" id="@i"><a class="page-link" href="#" onclick="paginationPureJS(@i)">@i</a></li>
                                        }
                                    }
                                    else
                                    {
                                        for (int i = noOfPost - 9; i <= noOfPost; i++)
                                        {
                                            <li class="page-item" id="@i"><a class="page-link" href="#" onclick="paginationPureJS(@i)">@i</a></li>
                                        }

                                    }
                                }

                            }
                            <li class="page-item next"><a class="page-link" href="#" onclick="next(@next_idx, @NoOfBooking)">Next »</a></li>
                            <li class="page-item previous"><a class="page-link" href="#" onclick="paginationPureJS(@Model.NoOfBooking)">Last »</a></li>
                        </ul>
                    </nav>

                </div>

            }

            <div class="card-footer d-flex justify-content-center">

                <button type="button" class="btn btn-lg m-3" align="center"
                        style="background:cadetblue;color:white" id="show-approved" onclick="location.href = '@Url.Action("BookingSearchBySlotId", "Booking", new {})'">
                    Search History of Owner by Slot Id
                </button>

            </div>
        </div>

    </div>
</body>
<script>
    $("#" + @Model.index).addClass("active");
    var s2 = $("#searchfield").val();
    var s3 = $("#complete").val();
    var s4 = $("#type").val();
    var s5 = $("#tokenassigned").val();
    var s6 = $("#checkedin").val();
    var s7 = $("#checkedout").val();
    var fromDate = $("#FromDate").val();
    var toDate = $("#ToDate").val();

    function search() {
        var s = $("#searchfield").val();
        s3 = $("#complete").val();
        s4 = $("#type").val();
        s5 = $("#tokenassigned").val();
        s6 = $("#checkedin").val();
        s7 = $("#checkedout").val();

        fromDate = $("#FromDate").val();
        toDate = $("#ToDate").val();

        GoTo(1, s);
    }

    function previous(i, n) {
        if (i >= 1) {
            GoTo(i);
        }
    }

    function next(i, n) {
        if (i <= n) {
            GoTo(i);
        }
    }

    function paginationPureJS(i) {
        GoTo(i);
    }

    function GoTo(index, paramSearch) {
        var searchfield = s2;
        if (paramSearch != null) {
            searchfield = paramSearch;
        }

        window.location.href = "../Booking/OwnerRoomBookingManagement?searchfield=" + searchfield + "&index=" + index + '&bookingcomplete=' + s3 + '&type=' + s4 + '&tokenassigned=' + s5 + '&checkedin=' + s6 + '&checkedout=' + s7 + '&fromDate=' + fromDate + '&toDate=' + toDate;
    }
</script>

<script>
    function editfunction(booking_id) {
        window.location.href = "/Booking/OwnerRoomBookingEdit?ownerRoomBookngId=" + booking_id;
    }
</script>

<script>
    function deletefunction(booking_id) {
        window.location.href = "/Booking/OwnerRoomBookingDelete?ownerRoomBookingId=" + booking_id;
    }
</script>

<script>
    $("#" + @Model.index).addClass("active");
</script>

<script>
    $(document).ready(function() {
        var taskRoles = "@Model.TaskRoles";
        if (taskRoles[0] == '0') {
            $('table tr').find('td:eq(0),th:eq(0)').remove();
            if (taskRoles[3] == '0') {
                $('table tr').find('td:eq(0),th:eq(0)').remove();
                if (taskRoles[4] == '0') {
                    $('table tr').find('td:eq(0),th:eq(0)').remove();
                }
            } else {
                if (taskRoles[4] == '0') {
                    $('table tr').find('td:eq(1),th:eq(1)').remove();
                }
            }
        } else {
            if (taskRoles[3] == '0') {
                $('table tr').find('td:eq(1),th:eq(1)').remove();
                if (taskRoles[4] == '0') {
                    $('table tr').find('td:eq(1),th:eq(1)').remove();
                }
            } else {
                if (taskRoles[4] == '0') {
                    $('table tr').find('td:eq(2),th:eq(2)').remove();
                }
            }
        }
        if (taskRoles[1] == '0') {
            $("#newItem").remove();
        }
    });
</script>

<script>
    $(document).ready(function() {

        $("#editItem").remove();
        $("#saveItem").remove();
        $("#deleteItem").remove();
        $("#dashboardItem").remove();
        $('#printItem').click(function(){
            window.print();
        });
           $("#newItem").click(function() {
            document.location = '@Url.Action("BookingCreate", "Booking")';
        });
        $('#reloadItem').click(function() {
            location.reload();
        });
        $("#reportItem").click(function() {
         document.location = '@Url.Action("Report", "Booking")';
        });


    });
</script>
